/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 07.03.2011
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATtiny13
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/

#include <tiny13.h>

void keyboard (void);             //, 

#define ON  PORTB |= 0x01         // 1
#define OFF  PORTB &= ~0x01       // 0
#define GREEN_OFF  PORTB.2=1      // "  "
#define GREEN_ON  PORTB.2=0       // "  "
#define RED_OFF  PORTB.1=1        // "  "
#define RED_ON  PORTB.1=0         // "  "
#define ALL_OFF PORTB |= 0x06     //  
#define DOWN (PINB.4)             // ""
#define UP (PINB.3)               // ""
#define MIN 0x13                  // 
#define MAX 0x07                  // 
#define NORM 0x10                 // 
#define ch 0                      //  

        //      0  255
unsigned char a=MIN;     // 

// Timer 0 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
OFF;
}

// Timer 0 output compare B interrupt service routine
interrupt [TIM0_COMPB] void timer0_compb_isr(void)
{
ON;
ALL_OFF;
keyboard();              //  
OCR0A=a;
TCNT0=0x00;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State5=T State4=T State3=T State2=1 State1=1 State0=0 
PORTB=0x3D;               //       xx111110  B
DDRB=0x07;                //           xx000111  B

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Normal top=0xFF
// OC0A output: Set on compare match
// OC0B output: Set on compare match
TCCR0A=0x00;                        //  0xF0
TCCR0B=0x05;                        // 
TCNT0=0x00;
OCR0A=a;                            //
OCR0B=0xBA;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x0C;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR0=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// Global enable interrupts
#asm("sei")


while (1)
      {     

      if (a==MAX)RED_ON;                //
      if (a==MIN)GREEN_ON;              //
      if (a==NORM){RED_ON;GREEN_ON;}    //
             
      }
}

void keyboard (void){             //(7)    "UP"  "DOWN"
if ((UP==0)&(a>MAX))              //   "UP",   "a"  "MAX" (0x03)
a--;                              // "a"   1
if ((DOWN==0)&(a<MIN))            //   "DOWN",   "a"  "MIN" (0x83)
a++;                              // "a"   1
}